% created with MATLAB ver.: 8.1.0.604 (R2013a) on Mac OSX Yosemite 10.90.1
%
% created by: Birgit Brggemeier; birgit_biz@online.de
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 1.1. find longest pulse train and set length of f to longest
length_f_h_local_min = 0;

for ii = 1:length(PulseTrain.start)
    length_f_h(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii));
    
    if length_f_h(ii)> length_f_h_local_min
        length_f_h_local_min = length_f_h(ii);
    end
    
end

% 1.2. Generate triangle function

length_f = length_f_h_local_min; % length of one bout of song

y_h = 0.8; % y_h is the increase in amplitude I set slopes to take

m_mel = M_melanogaster/(Fs/original_Fs);
m_sim = M_simulans/(Fs/original_Fs);
m_yak = M_yakuba/(Fs/original_Fs);

x_mel = y_h/m_mel;
x_sim = y_h/m_sim;
x_yak = y_h/m_yak;

% generate slope function for D. melanogaster
f_one_diamond_mel = [1-y_h:m_mel:1 , 1-m_mel:-m_mel:1-y_h];

n_diamonds_mel = ceil(length_f/x_mel);

f_mel = repmat(f_one_diamond_mel, 1, n_diamonds_mel);
f_mel = f_mel(1:length_f)';

% generate slope function for D. simulans
f_one_diamond_sim = [1-y_h:m_sim:1 , 1-m_sim:-m_sim:1-y_h];

n_diamonds_sim = ceil(length_f/x_sim);

f_sim = repmat(f_one_diamond_sim, 1, n_diamonds_sim);
f_sim = f_sim(1:length_f)';

% generate slope function for D. yakuba
f_one_diamond_yak = [1-y_h:m_yak:1 , 1-m_yak:-m_yak:1-y_h];

n_diamonds_yak = ceil(length_f/x_yak);

f_yak = repmat(f_one_diamond_yak, 1, n_diamonds_yak);
f_yak = f_yak(1:length_f)';

amp_compensation_constant = 1;%/(1-(y_h*0.5));

%% 2. Multiply each pulse train in constant_adj with the species specific respective SAS slope functions f_mel(t), f_sim(t) or f_yak(t) to generate mel_slope_SAS, sim_slope_SAS or yak_slope_SAS respectively
mel_slope_SAS = constant;
sim_slope_SAS = constant;
yak_slope_SAS = constant;
for ii = 1:length(PulseTrain.start)
    if length(PulseTrain.start(ii) : PulseTrain.stop(ii)) > length(f_mel)
        difference(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii)) - length(f_mel);
        f_mel =  [f_mel zeros(1,difference(ii))];
        mel_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_mel' * amp_compensation_constant;
    elseif length(PulseTrain.start(ii) : PulseTrain.stop(ii)) == length(f_mel)
        mel_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_mel' * amp_compensation_constant;
    elseif length(PulseTrain.start(ii) : PulseTrain.stop(ii)) < length(f_mel)
        difference(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii)) - length(f_mel);
        mel_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_mel(1:end- abs(difference(ii)))' * amp_compensation_constant;
    end
    
    if length(PulseTrain.start(ii) : PulseTrain.stop(ii)) > length(f_sim)
        difference(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii)) - length(f_sim);
        f_sim =  [f_sim zeros(1,difference(ii))];
        sim_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_sim' * amp_compensation_constant;
    elseif length(PulseTrain.start(ii) : PulseTrain.stop(ii)) == length(f_sim)
        sim_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_sim' * amp_compensation_constant;
    elseif length(PulseTrain.start(ii) : PulseTrain.stop(ii)) < length(f_sim)
        difference(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii)) - length(f_sim);
        sim_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_sim(1:end- abs(difference(ii)))' * amp_compensation_constant;
    end
    
    if length(PulseTrain.start(ii) : PulseTrain.stop(ii)) > length(f_yak)
        difference(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii)) - length(f_yak);
        f_yak =  [f_yak zeros(1,difference(ii))];
        yak_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_yak' * amp_compensation_constant;
    elseif length(PulseTrain.start(ii) : PulseTrain.stop(ii)) == length(f_yak)
        yak_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_yak' * amp_compensation_constant;
    elseif length(PulseTrain.start(ii) : PulseTrain.stop(ii)) < length(f_yak)
        difference(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii)) - length(f_yak);
        yak_slope_SAS(PulseTrain.start(ii) : PulseTrain.stop(ii))  = constant(PulseTrain.start(ii) : PulseTrain.stop(ii)) .* f_yak(1:end- abs(difference(ii)))' * amp_compensation_constant;
    end
end