%% Apply a sigmoid with k =  mean(slope_of_species) to song with constant amplitude
%
% created with MATLAB ver.: 8.1.0.604 (R2013a) on Mac OSX Yosemite 10.90.1
%
% created by: Birgit Brggemeier; birgit_biz@online.de
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 1. set constants
% 1.1. find longest pulse train and set length of length_f_h_local_max to longest pulse train
length_f_h_local_max = 0;

for ii = 1:length(PulseTrain.start)
    length_f_h(ii) = length(PulseTrain.start(ii) : PulseTrain.stop(ii));
    
    if length_f_h(ii)> length_f_h_local_max
        length_f_h_local_max = length_f_h(ii);
    end
    
end

% 1.2. load mean slope_of_species

length_f = length_f_h_local_max; % length of one bout of song

y_start = 0.25; % y_h is the baseline amplitude I set; after normalisation to 1 the baseline amplitude will be at 0.2 as in the other SAS transformations 

mean_m{1} = M_melanogaster/(Fs/original_Fs);
mean_m{2} = M_simulans/(Fs/original_Fs);
mean_m{3} = M_yakuba/(Fs/original_Fs);

% 1.3. Generate sigmoid function
p = 0.9999;

x_h = sym('x');
for ii =1:length(mean_m)
x{ii} = double(solve((1./(1+exp(mean_m{ii}*(-x_h+0))) == p ), x_h));
offset{ii} = floor(x{ii}/2);

f_one_sigmoid{ii} = sigmf(1:x{ii}, [mean_m{ii}, offset{ii}]);
f_one_sigmoid_structure{ii} = [f_one_sigmoid{ii}, fliplr(f_one_sigmoid{ii})]+y_start;
end

amp_compensation_constant = 1;%/(1-(y_h*0.5));

for ii = 1:length(mean_m)
    for ee = 1:length(PulseTrain.start)
        Pulse_I{ii}{ee} = PulseTrain.start(ee):PulseTrain.stop(ee);
    end
    Pulse_I_vector{ii} = horzcat(Pulse_I{ii}{:});
    
    f_sigmoids{ii} = repmat(f_one_sigmoid_structure{ii}, 1,ceil(length(Pulse_I_vector{ii})/length(f_one_sigmoid_structure{ii})));
    f_sigmoids{ii} = f_sigmoids{ii}(1:length(Pulse_I_vector{ii}));
end



%% 2. Multiply pulses with the species specific respective SAS sigmoid slope functions 
for ii = 1:length(mean_m)
Song_species_slope{ii} = constant;
Song_species_slope{ii}(Pulse_I_vector{ii}) = (Song_species_slope{ii}(Pulse_I_vector{ii}).*f_sigmoids{ii});
Song_species_slope{ii}(Pulse_I_vector{ii}) = Song_species_slope{ii}(Pulse_I_vector{ii})./max(Song_species_slope{ii}(Pulse_I_vector{ii}));
end


%% 7. set amplitude to similar absolute levels
pulse_song_only{1} = Song_species_slope{1}(Pulse_I_vector{1});
posI = find(pulse_song_only{1}>0);
abs_amp{1} = sum(pulse_song_only{1}(posI));
min_abs_amp = abs_amp{1};
ID_min_abs_amp = 1;

for ii = 2:length(mean_m)
    pulse_song_only{ii} = Song_species_slope{ii}(Pulse_I_vector{ii});
    posI = find(pulse_song_only{ii}>0);
    abs_amp{ii} = sum(pulse_song_only{ii}(posI));
    if min_abs_amp>abs_amp{ii}
        min_abs_amp = abs_amp{ii};
        ID_min_abs_amp = ii;
    end
end

ID_rest = 1:3;
ID_rest(ID_min_abs_amp) = [];

for ii = 1:length(ID_rest)
    amp_adjustment_constant(ii) = abs_amp{ID_rest(ii)}/min_abs_amp;
    for ee = 1:length(PulseTrain.start)
        Song_species_slope{ID_rest(ii)}(PulseTrain.start(ee):PulseTrain.stop(ee)) =  Song_species_slope{ID_rest(ii)}(PulseTrain.start(ee):PulseTrain.stop(ee))./amp_adjustment_constant(ii);
    end
end