% created with MATLAB ver.: 8.1.0.604 (R2013a) on Mac OSX Yosemite 10.90.1
%
% created by: Birgit Brggemeier; birgit_biz@online.de
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 0. segment your song, you want to manipulate
% see files Automatically_segment_*SPECIESNAME*_song_and_analyseSAS

%% load melanogaster song
cd /Users/birgitbruggemeier/Desktop/FlySong/FlySongPlayback/SoundFiles/;
load('real_playback_segmented.mat');

%% load simulans song
cd /Users/birgitbruggemeier/Desktop/FlySong/SAS_species/simulans/3000fps/;
load('Playback_SIMULANS_Audio020715_1502.mat');

%% load yakuba song
cd /Users/birgitbruggemeier/Desktop/FlySong/SAS_species/yakuba/3000fps/;
load('Playback_YAKUBA_Audio020715_0958.mat');


%% 1. generate constant song as base

for ii = 1:length(Pulses.AmpCull.w0)
    peak_amp_max(ii) = max(Data.d(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii)));
    peak_amp_min(ii) = min(Data.d(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii)));
end

Fs = Data.fs;

% 3. Calculate average amplitude of peak amplitudes

mean_peak_amp = mean(peak_amp_max);

% 4. Normalise amplitudes by dividing all pulses (identified by start and
% end index) with their respective max amplitude value (see 2.)
norm_amp_real_pos = zeros(1, length(Data.d));
norm_amp_real_pos(find(Data.d>0)) = Data.d(find(Data.d>0));
norm_amp_real_neg = zeros(1, length(Data.d));
norm_amp_real_neg(find(Data.d<0)) = Data.d(find(Data.d<0));

for ii = 1:length(Pulses.AmpCull.w0)
    
    if ii == 1
        
        norm_amp_real_pos(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))  = norm_amp_real_pos(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))./peak_amp_max(ii);
        norm_amp_real_neg(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))  = norm_amp_real_neg(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))./abs(peak_amp_min(ii));
        
    else
        
        if Pulses.AmpCull.w0(ii) <= Pulses.AmpCull.w1(ii-1)
            overlap = Pulses.AmpCull.w1(ii-1) - Pulses.AmpCull.w0(ii) +1;
            norm_amp_real_pos(Pulses.AmpCull.w0(ii)+overlap:Pulses.AmpCull.w1(ii))  = norm_amp_real_pos(Pulses.AmpCull.w0(ii)+overlap:Pulses.AmpCull.w1(ii))./peak_amp_max(ii);
            norm_amp_real_neg(Pulses.AmpCull.w0(ii)+overlap:Pulses.AmpCull.w1(ii))  = norm_amp_real_neg(Pulses.AmpCull.w0(ii)+overlap:Pulses.AmpCull.w1(ii))./abs(peak_amp_min(ii));
        else
            norm_amp_real_pos(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))  = norm_amp_real_pos(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))./peak_amp_max(ii);
            norm_amp_real_neg(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))  = norm_amp_real_neg(Pulses.AmpCull.w0(ii):Pulses.AmpCull.w1(ii))./abs(peak_amp_min(ii));
        end
    end
end

norm_amp_real = norm_amp_real_pos;
norm_amp_real(find(norm_amp_real_pos==0)) = norm_amp_real_neg(find(norm_amp_real_pos==0));

constant = norm_amp_real; %AVERAGE_norm_amp_real;
%% 2. Compute start and end points (p(1,ii) = start; p(2,ii) = end) and duration of pulse trains

cd /Users/birgitbruggemeier/FlySong/HypothesisTesting/;

prompt = 'What is the flies species of the song you wish to manipulate? ';
species = input(prompt, 's');

[ SongLabel, I_start_NoSong, I_end_NoSong, SineTrain, PulseTrain, bTrain, I_start_PulseSong, I_end_PulseSong, I_start_SineSong, I_end_SineSong, timelag] = SongTypeLabeling( Data, Pulses, Sines , species);

%% 3.  load average slopes of fly species (see above)
prompt2 = 'What type of slopes should be the basis for SAS manipulation? You can choose from "mean", "median" or "mean sigmoid" of species specific SAS slopes. ';
slope = input(prompt2, 's');

original_Fs = 3000; % sampling frequency of the species song data

if strcmpi(slope, 'mean') == 1 % MEAN
    % 3.1. MEAN slope
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/melanogaster/3000fps/SAS_Analysed_dat';
    M_melanogaster_h = load('SAS_summarystats_melanogaster', 'M_SAS');
    M_melanogaster = M_melanogaster_h.M_SAS;
    
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/simulans/3000fps/SAS_Analysed_dat';
    M_simulans_h = load('SAS_summarystats_simulans', 'M_SAS');
    M_simulans = M_simulans_h.M_SAS;
    
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/yakuba/3000fps/SAS_Analysed_dat';
    M_yakuba_h = load('SAS_summarystats_yakuba', 'M_SAS');
    M_yakuba = M_yakuba_h.M_SAS;
    
    
    generateConstantSASslopeSong; % this process generates songs with constant slopes as specified in M_melanogaster, M_simulans and M_yakuba
    
    % save files with MEAN slope
    cd /Users/birgitbruggemeier/Desktop/FlySong/FlySongPlayback/SoundFiles/;
    if strcmpi(species,'melanogaster') == 1
        % for Fs = 10000;
        wavwrite(mel_slope_SAS.*0.25, 10000, 'MELANOGASTER_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 10000, 'MELANOGASTER_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 10000, 'MELANOGASTER_yak_slope_SAS_real_QUARTER_loud.wav');
    elseif strcmpi(species,'simulans') == 1
        % for Fs = 3000; and Simulans Song
        wavwrite(mel_slope_SAS.*0.25, 3000, 'SIMULANS_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 3000, 'SIMULANS_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 3000, 'SIMULANS_yak_slope_SAS_real_QUARTER_loud.wav');
    elseif strcmpi(species,'yakuba') == 1
        % for Fs = 3000; and Yakuba Song
        wavwrite(mel_slope_SAS.*0.25, 3000, 'YAKUBA_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 3000, 'YAKUBA_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 3000, 'YAKUBA_yak_slope_SAS_real_QUARTER_loud.wav');
    else
        error('SongTypeLabeling:SpeciesDescriptionWrong', 'Wrong species description. You can choose from "Yakuba", "Simulans" and "Melanogaster" only.');
    end
    
    
elseif strcmpi(slope, 'median') == 1 % MEDIAN
    % 3.2. MEDIAN slope
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/melanogaster/3000fps/SAS_Analysed_dat';
    concat_M_melanogaster = load('SAS_summarystats_melanogaster', 'concat_M_SAS');
    M_melanogaster = median(concat_M_melanogaster.concat_M_SAS);
    
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/simulans/3000fps/SAS_Analysed_dat';
    concat_M_simulans = load('SAS_summarystats_simulans', 'concat_M_SAS');
    M_simulans = median(concat_M_simulans.concat_M_SAS);
    
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/yakuba/3000fps/SAS_Analysed_dat';
    concat_M_yakuba = load('SAS_summarystats_yakuba', 'concat_M_SAS');
    M_yakuba = median(concat_M_yakuba.concat_M_SAS);
    
    
    generateConstantSASslopeSong; % this process generates songs with constant slopes as specified in M_melanogaster, M_simulans and M_yakuba
    
    % save files with MEDIAN slope
    cd /Users/birgitbruggemeier/Desktop/FlySong/FlySongPlayback/SoundFiles/;
    if strcmpi(species,'melanogaster') == 1
        % for Fs = 10000;
        wavwrite(mel_slope_SAS.*0.25, 10000, 'MEDIAN_MELANOGASTER_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 10000, 'MEDIAN_MELANOGASTER_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 10000, 'MEDIAN_MELANOGASTER_yak_slope_SAS_real_QUARTER_loud.wav');
        
    elseif strcmpi(species,'simulans') == 1
        % for Fs = 3000; and Simulans Song
        wavwrite(mel_slope_SAS.*0.25, 3000, 'MEDIAN_SIMULANS_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 3000, 'MEDIAN_SIMULANS_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 3000, 'MEDIAN_SIMULANS_yak_slope_SAS_real_QUARTER_loud.wav');
        
    elseif strcmpi(species,'yakuba') == 1
        % for Fs = 3000; and Yakuba Song
        wavwrite(mel_slope_SAS.*0.25, 3000, 'MEDIAN_YAKUBA_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 3000, 'MEDIAN_YAKUBA_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 3000, 'MEDIAN_YAKUBA_yak_slope_SAS_real_QUARTER_loud.wav');
    else
        error('SongTypeLabeling:SpeciesDescriptionWrong', 'Wrong species description. You can choose from "Yakuba", "Simulans" and "Melanogaster" only.');
    end
    
elseif strcmpi(slope, 'mean sigmoid')
    
    % 3.5. mean SIGMOID slope
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/melanogaster/3000fps/SAS_Analysed_dat';
    M_melanogaster_h = load('SAS_summarystats_melanogaster', 'M_SAS');
    M_melanogaster = M_melanogaster_h.M_SAS;
    
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/simulans/3000fps/SAS_Analysed_dat';
    M_simulans_h = load('SAS_summarystats_simulans', 'M_SAS');
    M_simulans = M_simulans_h.M_SAS;
    
    cd '/Users/birgitbruggemeier/Desktop/FlySong/SAS_species/yakuba/3000fps/SAS_Analysed_dat';
    M_yakuba_h = load('SAS_summarystats_yakuba', 'M_SAS');
    M_yakuba = M_yakuba_h.M_SAS;
    
    % run process that generates sigmoid slopes
    generateSigmoidSASslopeSong; % this process generates songs with constant sigmoid slopes as specified in M_melanogaster, M_simulans and M_yakuba
    
    % rename songs for saving afterwards
    mel_slope_SAS = Song_species_slope{1};
    sim_slope_SAS = Song_species_slope{2};
    yak_slope_SAS = Song_species_slope{3};
    
    % save files with MEAN slope
    cd /Users/birgitbruggemeier/Desktop/FlySong/FlySongPlayback/SoundFiles/;
    if strcmpi(species,'melanogaster') == 1
        % for Fs = 10000;
        wavwrite(mel_slope_SAS.*0.25, 10000, 'meanSIGMOID_MELANOGASTER_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 10000, 'meanSIGMOID_MELANOGASTER_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 10000, 'meanSIGMOID_MELANOGASTER_yak_slope_SAS_real_QUARTER_loud.wav');
    elseif strcmpi(species,'simulans') == 1
        % for Fs = 3000; and Simulans Song
        wavwrite(mel_slope_SAS.*0.25, 3000, 'meanSIGMOID_SIMULANS_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 3000, 'meanSIGMOID_SIMULANS_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 3000, 'meanSIGMOID_SIMULANS_yak_slope_SAS_real_QUARTER_loud.wav');
    elseif strcmpi(species,'yakuba') == 1
        % for Fs = 3000; and Yakuba Song
        wavwrite(mel_slope_SAS.*0.25, 3000, 'meanSIGMOID_YAKUBA_mel_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(sim_slope_SAS.*0.25, 3000, 'meanSIGMOID_YAKUBA_sim_slope_SAS_real_QUARTER_loud.wav');
        wavwrite(yak_slope_SAS.*0.25, 3000, 'meanSIGMOID_YAKUBA_yak_slope_SAS_real_QUARTER_loud.wav');
    else
        error('SongTypeLabeling:SpeciesDescriptionWrong', 'Wrong species description. You can choose from "Yakuba", "Simulans" and "Melanogaster" only.');
    end
    
else
    error('SongTypeLabeling:SpeciesDescriptionWrong', 'Wrong species description. You can choose from "Yakuba", "Simulans" and "Melanogaster" only.');
end

